import psvm.*;

SVM model;
float[][] trainingPoints;
int[] labels;

Table data;

PGraphics modelDisplay;
boolean showModel = false;

void setup(){
  size(500,500);
  
  data = loadTable("positions.csv");
  
  // each training point will have two entries (x and y)
  trainingPoints = new float[data.getRowCount()][6];
  labels = new int[data.getRowCount()];
  
}


void draw(){
}

// on mouse click, for any given point
// test it against the model and print the result set
void mousePressed(){
  double[] p = new double[2];
  p[0] = (double)mouseX/width;
  p[1] = (double)mouseY/height;
  println((int)model.test(p));
}

void setupSVM(){
  // loop through the CSV rows to create the trainingPoints and labels
  int i = 0;
  for (TableRow row : data.rows()) {
    float[] p = new float[6];
    for (int j=0; i<6; i++){
      p[i] = row.getFloat(i+5);
    }
    trainingPoints[i] = p;
    
    for (int j=0; i<5; i++){
      if( row.getInt(j) > 0) labels[i] = j;
    }
    
    i++;
  }
  
  // initialize our model and problem objects
  model = new SVM(this);
  SVMProblem problem = new SVMProblem();
  problem.setNumFeatures(6);
  // load the problem with the labels and training data
  problem.setSampleData(labels, trainingPoints);
  // train the model
  model.train(problem);
}

