import controlP5.*;
import processing.serial.*;

Serial myPort; 
PrintWriter output;

boolean first = false;
boolean first2 = false;
ControlP5 cp5;
String inData = "";
float inByte1 = 0;
float inByte2 = 0;
float inByte3 = 0;
float inByte4 = 0;
float inByte5 = 0;
float inByte6 = 0;
int mY = 50;

int finger1 = 0;
int finger2 = 0;
int finger3 = 0;
int finger4 = 0;
int finger5 = 0;

String outfile = "positions.txt";

void setup () {
 // set the window size:
 size(900, 600);        
 println(Serial.list());
 myPort = new Serial(this, Serial.list()[1], 9600);
 myPort.bufferUntil('\n');
 background(0);
 smooth();
 cp5 = new ControlP5(this);
 output = createWriter(outfile);
 
   cp5.addToggle("f1")
     .setPosition(20,10)
     .setSize(50,20)
     .setValue(false)
     .setMode(ControlP5.SWITCH)
     ;
     
   cp5.addToggle("f2")
     .setPosition(100,10)
     .setSize(50,20)
     .setValue(false)
     .setMode(ControlP5.SWITCH)
     ;
     
   cp5.addToggle("f3")
     .setPosition(180,10)
     .setSize(50,20)
     .setValue(false)
     .setMode(ControlP5.SWITCH)
     ;
     
   cp5.addToggle("f4")
     .setPosition(240,10)
     .setSize(50,20)
     .setValue(false)
     .setMode(ControlP5.SWITCH)
     ;
     
   cp5.addToggle("f5")
     .setPosition(320,10)
     .setSize(50,20)
     .setValue(false)
     .setMode(ControlP5.SWITCH)
     ;
 
   cp5.addButton("recordvalue")
     .setPosition(400,10)
     .setSize(100,19)
     .setValue(0)
     ;
     
   cp5.addButton("close")
     .setPosition(520,10)
     .setSize(50,19)
     .setValue(0)
     ;
 
   cp5.addSlider("led1")
     .setPosition(680,50)
     .setSize(150,20)
     .setRange(0,255)
     .setNumberOfTickMarks(50)
     ;
     
  cp5.addSlider("led2")
     .setPosition(680,150)
     .setSize(150,20)
     .setRange(0,255)
     .setNumberOfTickMarks(50)
     ;
     
   cp5.addSlider("led3")
     .setPosition(680,250)
     .setSize(150,20)
     .setRange(0,255)
     .setNumberOfTickMarks(50)
     ;
     
   cp5.addSlider("led4")
     .setPosition(680,350)
     .setSize(150,20)
     .setRange(0,255)
     .setNumberOfTickMarks(50)
     ;
     
   cp5.addSlider("led5")
     .setPosition(680,450)
     .setSize(150,20)
     .setRange(0,255)
     .setNumberOfTickMarks(50)
     ;
 
}

void draw () {
   if (inData != null) {
   inData = trim(inData);
   String[] inString = split(inData, ',');
   
   if (inString.length == 6){
   inByte1 = float(inString[0]); 
   inByte2 = float(inString[1]); 
   inByte3 = float(inString[2]); 
   inByte4 = float(inString[3]); 
   inByte5 = float(inString[4]); 
   inByte6 = float(inString[5]); 
   
   float inByte1b = map(inByte1, 0, 1023, 0, height-mY);
   float inByte2b = map(inByte2, 0, 1023, 0, height-mY);
   float inByte3b = map(inByte3, 0, 1023, 0, height-mY);
   float inByte4b = map(inByte4, 0, 1023, 0, height-mY);
   float inByte5b = map(inByte5, 0, 1023, 0, height-mY);
   float inByte6b = map(inByte6, 0, 1023, 0, height-mY);
   
   //background(0);
   fill(0);
   rect(0, mY, 650, height-mY);
   stroke(127,34,255);
   fill(255);
   rect(0,height-inByte1b, 100, inByte1);
   rect(110,height-inByte2b, 100, inByte2);
   rect(220,height-inByte3b, 100, inByte3);
   rect(330,height-inByte4b, 100, inByte4);
   rect(440,height-inByte5b, 100, inByte5);
   rect(550,height-inByte6b, 100, inByte6);

   }
 inData = null; 
 }
}
 
void serialEvent (Serial myPort) {

 inData = myPort.readStringUntil('\n');

}

void f1(boolean theFlag) {
  if(theFlag==true) {
    finger1 = 1;
  } else {
    finger1 = 0;
  }
}

void f2(boolean theFlag) {
  if(theFlag==true) {
    finger2 = 1;
  } else {
    finger2 = 0;
  }
}

void f3(boolean theFlag) {
  if(theFlag==true) {
    finger3 = 1;
  } else {
    finger3 = 0;
  }
}

void f4(boolean theFlag) {
  if(theFlag==true) {
    finger4 = 1;
  } else {
    finger4 = 0;
  }
}

void f5(boolean theFlag) {
  if(theFlag==true) {
    finger5 = 1;
  } else {
    finger5 = 0;
  }
}

void recordvalue(int theValue){
  if (first){
  output.print(finger1);
  output.print(',');
  output.print(finger2);
  output.print(',');
  output.print(finger3);
  output.print(',');
  output.print(finger4);
  output.print(',');
  output.print(finger5);
  output.print(',');
  output.print(inByte1);
  output.print(',');
  output.print(inByte2);
  output.print(',');
  output.print(inByte3);
  output.print(',');
  output.print(inByte4);
  output.print(',');
  output.print(inByte5);
  output.print(',');
  output.println(inByte6);
  output.flush();
  }
  first = true;
}

void close(int theValue){
  if (first2){
    output.flush();
    output.close();
    exit();
  }
  first2 = true; 
}

void led1(float theColor) {
}

void led2(float theColor) {
}

void led3(float theColor) {
}

void led4(float theColor) {
}

void led5(float theColor) {
}
